/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.person.boundary;

import de.ivu.elect.business.person.entity.PersonenVerknuepfung;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class PersonenVerknuepfungDAO extends AbstractPersonenVerknuepfungDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(PersonenVerknuepfung personenVerknuepfung){
    getEntityManager().persist(personenVerknuepfung);
  }

  public void remove(PersonenVerknuepfung personenVerknuepfung){
    getEntityManager().remove(personenVerknuepfung);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: NurPerson1NoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM PersonenVerknuepfung obj WHERE obj.person1 = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<PersonenVerknuepfung> findByNurPerson1( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten person) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PersonenVerknuepfung.findByNurPerson1" ,  person  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByNurPerson1( person  ));
        }
        return (java.util.List<PersonenVerknuepfung>) cached;
        }
            return super.findByNurPerson1( person  );
            }
                                        
        /**
        * Name: PersonNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM PersonenVerknuepfung obj WHERE obj.person1 = ?1 OR obj.person2 = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<PersonenVerknuepfung> findByPerson( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten person) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PersonenVerknuepfung.findByPerson" ,  person  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByPerson( person  ));
        }
        return (java.util.List<PersonenVerknuepfung>) cached;
        }
            return super.findByPerson( person  );
            }
                                            
        /**
        * Name: WahlAndVerknuepfungsGrundlageAndVerknuepfungsStatusNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT pv FROM PersonenVerknuepfung pv WHERE pv.person1.wahl=?1 AND pv.verknuepfungsGrundlage=?2 AND pv.verknuepfungsStatus=?3<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<PersonenVerknuepfung> findByWahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.person.entity.VerknuepfungsGrundlage verknuepfungsGrundlage,  @javax.annotation.Nonnull de.ivu.elect.business.person.entity.VerknuepfungsStatus verknuepfungsStatus) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PersonenVerknuepfung.findByWahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus" ,  wahl ,  verknuepfungsGrundlage ,  verknuepfungsStatus  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus( wahl ,  verknuepfungsGrundlage ,  verknuepfungsStatus  ));
        }
        return (java.util.List<PersonenVerknuepfung>) cached;
        }
            return super.findByWahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus( wahl ,  verknuepfungsGrundlage ,  verknuepfungsStatus  );
            }
                                        
        /**
        * Name: WahlNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT pv FROM PersonenVerknuepfung pv WHERE pv.person1.wahl=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<PersonenVerknuepfung> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PersonenVerknuepfung.findByWahl" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahl( wahl  ));
        }
        return (java.util.List<PersonenVerknuepfung>) cached;
        }
            return super.findByWahl( wahl  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}